<?php

namespace Teknisa\CADEST\Modules\Produto\Controllers;

use \Zeedhi\Framework\DTO\Request;
use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DTO\Response\Error;
use \Teknisa\Libs\Service\CRUD;
use \Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\CADEST\Modules\Produto\Services\Produto as ProdutoService;

class Prodarvoreprod extends \Teknisa\CADEST\Controllers\TeknisaCrud {

    protected $dataSourceNameToSave = 'prodarvoreprod';
    protected $service;

	function __construct(CRUD $crudService, ParameterBag $parameterBag, ProdutoService $service){
        parent::__construct($crudService, $parameterBag);
        $this->service = $service;
	}

	public function save (Request $request, Response $response) {
		try {
            $row = $request->getRow();
            if ($row['__is_new']) {
                $this->service->alreadyRelatedToTpTree($row['CDPRODUTO'], $row['NRTPARVPROD']);
            }
            parent::save($request, $response);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}

}